from sqlalchemy import Column, DateTime, ForeignKey, String, UniqueConstraint
from sqlalchemy.sql import func

from app.db.base_class import Base


class NoteTag(Base):
    id = Column(String, primary_key=True, index=True)
    note_id = Column(String, ForeignKey("note.id"), nullable=False)
    tag_id = Column(String, ForeignKey("tag.id"), nullable=False)
    created_at = Column(DateTime(timezone=True), server_default=func.now())
    
    # Ensure a tag can only be associated with a note once
    __table_args__ = (UniqueConstraint('note_id', 'tag_id', name='unique_note_tag'),)