from sqlalchemy import Column, DateTime, ForeignKey, Integer, String
from sqlalchemy.orm import relationship
from sqlalchemy.sql import func

from app.db.base_class import Base


class PlaylistSong(Base):
    id = Column(String, primary_key=True, index=True)
    playlist_id = Column(String, ForeignKey("playlist.id"), nullable=False)
    song_id = Column(String, ForeignKey("song.id"), nullable=False)
    position = Column(Integer, nullable=False)
    added_at = Column(DateTime(timezone=True), server_default=func.now())
    
    # Relationships
    playlist = relationship("Playlist", back_populates="songs")
    song = relationship("Song", back_populates="playlists")